% -------------------------------------------------------------------------
% License GPL v3.0
% Author: Borja Ayerdi <borja.ayerdi@ehu.es>
% Computational Intelligence Group <www.ehu.es/ccwintco>
% University Of The Basque Country (UPV/EHU) 
% Use this at your own risk!
% -------------------------------------------------------------------------

tic
load fisheriris
species= zeros(150,1);
species(1:50)=1;
species(51:100)=2;
species(101:end)=3;

% Matriz de datos y features, cada fila es un sample, cada columna una
% feature.
X=meas;

% Matriz de etiquetas, cada fila corresponde a la etiqueta de un sample.
Y=species;

% Porcentaje de datos que se destina para trainning.
porcentajeTrain=0.8;

% Dimensión del ensemble.
dim=5;

[trainIndex testIndex] = traintestbalance(Y,porcentajeTrain);
TrainingData = X(trainIndex,:);
TestingData = X(testIndex,:);
TrainingDataLabel = Y(trainIndex);
TestingDataLabel = Y(testIndex);

% TRAIN HERF
[herf inforotar numClass] = trainHERF(TrainingData,TrainingDataLabel, dim);

% TEST HERF
% En Y_HAT tienes la salida del clasificador
[votes, output] = testHERF(TestingData, herf, inforotar, numClass);

toc;

% Confusion matrix
[C,order] = confusionmat(output,TestingDataLabel);

% Accuracy.
Accuracy = sum(diag(C))/sum(C(:))

C
