% -------------------------------------------------------------------------
% License GPL v3.0
% Author: Borja Ayerdi <borja.ayerdi@ehu.es>
% Computational Intelligence Group <www.ehu.es/ccwintco>
% University Of The Basque Country (UPV/EHU) 
% Use this at your own risk!
% -------------------------------------------------------------------------

function [votes, Y_hat] = testHERF(TestingData, herf, inforotar, numClass)

dim= size(herf,2);
salidaV = zeros(size(TestingData,1),dim);

for i=1:dim
    
    R=inforotar{i}.R;
    mediaX=inforotar{i}.mediaX;
    
    if (mod(i,2)==0)
        elm = herf{1,i};
        salidaV(:,i) = testELM(TestingData*R-repmat(mediaX,[size(TestingData,1) 1]),elm);
    elseif (mod(i,2)==1)
        tree = herf{1,i};
        salidaV(:,i)= round(eval(tree,TestingData*R-repmat(mediaX,[size(TestingData,1) 1])));
    end
end

votes = zeros(size(TestingData,1),numClass);
for j=1:numClass
    for k=1:size(TestingData,1)
        votes(k,j)= numel(find(salidaV(k,:)==(j)));
    end
end

if (dim==1)
    Y_hat = salidaV;
else
    Y_hat = mode(salidaV')';
end

end