% -------------------------------------------------------------------------
% License GPL v3.0
% Author: Borja Ayerdi <borja.ayerdi@ehu.es>
% Computational Intelligence Group <www.ehu.es/ccwintco>
% University Of The Basque Country (UPV/EHU) 
% Use this at your own risk!
% -------------------------------------------------------------------------

function [trainIndex testIndex] = traintestbalance(labels,percTrain)

    % Create train and test balanced index.
    % Given labels and desired % of trainning set create a random index for
    % train and test set.

    numClass=max(labels);
    trainIndex=[];
    testIndex=[];

    for i=1:numClass
       W=find(labels==i);
       p = randperm(size(W,1));
       addTrainIndex=W(p(1:round(percTrain*size(W,1))));
       addTestIndex=W(p(round(percTrain*size(W,1))+1:end));
       trainIndex=[trainIndex; addTrainIndex];
       testIndex=[testIndex; addTestIndex];
    end

end